Imports SerializationDemo.Human
Imports SerializationDemo.Demo.util
Imports System.Xml
Imports System.io

Public Class Form1
#Region "Object instantiation"
    Private PeopleCollection As New People

#End Region

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Try
            'instantiate a person object
            Dim ThisPerson As New People.Person

            With ThisPerson
                'add some values to the objects properties
                .FirstName = txtFirstName.Text
                .LastName = txtLastName.Text

                'add our person object (ThisPerson) to the PeopleCollection
                PeopleCollection.Add(ThisPerson)

                'print out out info to the label on the form
                Me.lblInfo.Text = String.Concat(.FirstName, " ", .LastName, " was added to the collection!")
            End With

        Catch ex As Exception
            'generic error handling
            MessageBox.Show(ex.Message, "Error adding names to person class", MessageBoxButtons.OK)
        End Try
    End Sub

    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Try

            'I chose to use an xmldocument and a string for ease understanding.

            'instantiate a new xml document
            Dim Xdoc As New XmlDocument

            'set the string to the value of the serialzied object (PeopleCollection)
            Dim XmlString = GetXml(PeopleCollection, GetType(People)).Trim

            'instantiate a new dataset
            Dim DS As New DataSet

            'load the xmlstring into the xmldata. this will be used to display the raw text to the textbox on the form
            Xdoc.LoadXml(XmlString.trim)

            'read the string into the datasets readxml method
            DS.ReadXml(New StringReader(XmlString))

            'load up the gridview with the dataset
            Me.PersonGridView.DataSource = DS.Tables(0).DefaultView

            'display raw xml text
            Me.txtOutput.Text = XmlString

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error during class serialization", MessageBoxButtons.OK)

        End Try

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem1.Click
        Dim abt As New AboutBox1
        abt.Show()
    End Sub

  
    
End Class
